precision mediump float;
varying vec2 v_texture_position;
varying vec2 v_noise_position;

uniform sampler2D map_texture;
uniform sampler2D background_texture;
uniform vec3 background_color;

const lowp float threshold = 0.25;

void main() {
  lowp float shading = 1.0;
  lowp vec4 Csample = texture2D(map_texture, v_texture_position);
  lowp vec3 color = Csample.rgb;

  lowp float A = texture2D(map_texture, v_texture_position + vec2(-0.005, +0.005)).a;
  lowp float B = texture2D(map_texture, v_texture_position + vec2(-0.0015, +0.0015)).a;
  lowp float C = Csample.a;
  lowp float D = texture2D(map_texture, v_texture_position + vec2(+0.0015, -0.0015)).a;

  if(C < threshold) {
    color = background_color;

    if(A > threshold) shading = 0.6;
    else              shading = 0.5;
  } else {
    if(B < threshold)      shading = 0.1;
    else if(D < threshold) shading = 0.3;
    else                   shading = 0.2;
  }

  lowp vec3 noise = texture2D(background_texture, v_noise_position).rgb;
  gl_FragColor = vec4(noise * color - shading, 1.0);

//   gl_FragColor = vec4(C, C, C, 1.0);
}
